<template>
  <v-container fluid>
    <v-toolbar color="primary">

    <v-spacer></v-spacer>

    <v-toolbar-items>
      <v-btn text @click="logout">logout</v-btn>
    </v-toolbar-items>
    </v-toolbar>
    <v-card>
         <v-card-title>
           <span>Dunlopillothai Report ( {{ userData.length }} )</span>
           <v-spacer></v-spacer>
            <v-card-actions>
              <v-btn icon @click="loadData" class="mx-3"><v-icon medium>fas fa-sync</v-icon></v-btn>
               <download-excel
                  class="btn"
                  :data="userData"
                  :fields="json_fields"
                  worksheet="Dunlopillo"
                  name="Dunlopillothai_report.xls"
                  >
                  <v-icon medium>fas fa-download</v-icon>
              </download-excel>
            </v-card-actions>
          </v-card-title>
        <v-card-text>
          <v-layout row wrap>
            <v-flex xs6 lg4>
              <v-text-field
                v-model="search"
                append-icon="search"
                label="Search (Name, Mobile, Email)"
                single-line
                hide-details
              ></v-text-field>
            </v-flex>
            <v-flex xs3 lg4 class="px-3">
              <v-menu
                v-model="menu1"
                :close-on-content-click="false"
                full-width
                max-width="290"
              >
                <template v-slot:activator="{ on }">
                  <v-text-field
                    v-model="fromdate"
                    clearable
                    label="From Date"
                    readonly
                    v-on="on"
                  ></v-text-field>
                </template>
                <v-date-picker
                  v-model="fromdate"
                  @change="menu1 = false"
                  no-title
                  scrollable
                ></v-date-picker>
              </v-menu>
      </v-flex>
      <v-flex xs3 lg4 class="px-3">
        <v-menu
          v-model="menu2"
          :close-on-content-click="false"
          full-width
          max-width="290"
        >
          <template v-slot:activator="{ on }">
            <v-text-field
              v-model="todate"
              clearable
              label="To Date"
              readonly
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker
            v-model="todate"
            @change="menu2 = false"
            no-title
            scrollable
          ></v-date-picker>
        </v-menu>
      </v-flex>

          <v-flex xs12>
            <v-data-table
              :headers="headers"
              :items="userData"
              :page.sync="page"
              :items-per-page="25"
              :search="search"
              hide-default-footer
              class="elevation-1"

              @page-count="pageCount = $event"
            >
              <template v-slot:item.edit="{ item }">
                  <v-btn icon @click="editItem(item)">
                    <v-icon small>far fa-edit</v-icon>
                  </v-btn>
              </template>
               <template v-slot:item.createAt="{ item }">
                {{ getDatetime(item.createAt.seconds) }}
              </template>

              <template v-slot:item.lastTransactions="{ item }">
                {{ getLastDatetime(item) }}
              </template>

              <template v-slot:item.picCount="{ item }">
                <span v-if="item.picCount==null">
                  {{ 0 }}
                </span>
                <span v-else>
                {{ item.picCount }}
                </span>
              </template>
                <template v-slot:item.dataurl="{ item }">
                    <v-btn color="success" icon @click="openPic(item.lastTransactions[0].rawPicUrl)">
                      <v-icon small>fas fa-link</v-icon>
                    </v-btn>
              </template>
            </v-data-table>
          </v-flex>
          </v-layout>
        </v-card-text>
    </v-card>
     <div class="text-xs-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div>

      <v-dialog v-model="dialog" max-width="500px">
           <v-card>
            <v-card-title>
              <span class="headline">Edit</span>
            </v-card-title>

            <v-card-text>
              <v-container grid-list-md>
                <v-layout wrap>
                  <v-flex xs12 sm6 md4>
                    <v-text-field v-model="editedItem.fullName" label="Username-surname"></v-text-field>
                  </v-flex>
                  <v-flex xs12 sm6 md4>
                    <v-text-field v-model="editedItem.mobileNo" label="Mobile No."></v-text-field>
                  </v-flex>
                  <v-flex xs12 sm6 md4>
                    <v-text-field v-model="editedItem.email" label="E-Mail"></v-text-field>
                  </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="close">Cancel</v-btn>
              <v-btn color="blue darken-1" text @click="save">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-snackbar
          v-model="snackbar"
          :color="colorsnackbar"
          left
          bottom
          absolute
        >
          {{ textsnackbar }}
          <v-btn
            text
            @click="closeSnackbar"
          >
            Close
          </v-btn>
        </v-snackbar>

   </v-container>
</template>
<script>
export default {
  mounted () {
    let hasUser = this.$store.getters['userReport/checkArr']
    if (hasUser) {
      console.log('load data')
      this.loadData()
    }
  },
  data () {
    return {
      menu1: '',
      menu2: '',
      fromdate: '',
      todate: '',
      page: 1,
      dialog: false,
      pageCount: 0,
      itemsPerPage: 10,
      search: '',
      editedItem: {
        fullName: '',
        mobileNo: '',
        email: ''
      },
      editedIndex: '',
      headers: [
        { text: 'Edit', align: 'center', value: 'edit' },
        { text: 'Name-Surname', align: 'center', value: 'fullName' },
        { text: 'Mobile No.', align: 'center', value: 'mobileNo' },
        { text: 'E-mail', align: 'center', value: 'email' },
        { text: 'User Created Date', align: 'center', value: 'createAt' },
        { text: 'Latest Updated Date', align: 'center', value: 'lastTransactions' },
        { text: 'Count Updated', align: 'center', value: 'picCount' },
        { text: 'Contest Picture', align: 'center', value: 'dataurl' }
      ],
      json_meta: [
        [
          {
            'key': 'charset',
            'value': 'utf-8'
          }
        ]
      ],
      mutateFromDate: 0,
      mutateToDate: 0
    }
  },
  methods: {
    getDatetime (date) {
      let Fdate = new Date(0)
      Fdate.setSeconds(date)
      let day = Fdate.getDate()
      let month = Fdate.getMonth() + 1
      let year = Fdate.getFullYear()
      let dateShow = [year, month, day].join('-')
      //  let dateShow = Fdate.toLocaleDateString("en-US")
      return dateShow
    },
    getLastDatetime (date) {
      if (date.lastTransactions) {
        let lastSeconds = date.lastTransactions[0].createAt.seconds
        let Fdate = new Date(0)
        Fdate.setSeconds(lastSeconds)
        let day = Fdate.getDate()
        let month = Fdate.getMonth() + 1
        let year = Fdate.getFullYear()
        let dateShow = [year, month, day].join('-')
        //  let dateShow = Fdate.toLocaleDateString("en-US")
        return dateShow
      }
      return ''
    },
    openPic (url) {
      return window.open(url, '_blank')
    },
    loadData () {
      return this.$store.dispatch('userReport/getUserobjData')
    },
    editItem (item) {
      this.editedIndex = this.userData.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },
    save () {
      let editItemUser = {
        fullName: this.editedItem.fullName,
        email: this.editedItem.email,
        mobileNo: this.editedItem.mobileNo
      }
      this.$store.dispatch('userReport/editUserArr', {
        index: this.editedIndex,
        editObj: editItemUser,
        id: this.editedItem.id
      })
      this.dialog = false
    },
    close () {
      this.dialog = false
    },
    closeSnackbar () {
      this.snackbar = false
    },
    logout () {
      this.$store.dispatch('userReport/logout')
    }
  },
  watch: {
    fromdate (value) {
      let fromDateFloat = new Date(value)
      this.mutateFromDate = Date.parse(fromDateFloat) / 1000
    },
    todate (value) {
      let toDateFloat = new Date(value)
      this.mutateToDate = Date.parse(toDateFloat) / 1000
    }
  },
  computed: {
    userData () {
      let userArr = this.$store.getters['userReport/getUserArr']
      if (this.mutateFromDate > 0) {
        return userArr.filter(item => item.createAt.seconds > this.mutateFromDate)
      }
      if (this.mutateToDate > 0) {
        return userArr.filter(item => item.createAt.seconds < this.mutateToDate)
      }
      return userArr
    },
    dataurl () {
      return 'lastTransactions[0].rawPicUrl'
    },
    json_fields () {
      let Dates = {
        'Name-Surname': 'fullName',
        'Mobile No.': {
          field: 'mobileNo',
          callback: (value) => {
            return `'${value}`
          }
        },
        'E-mail': 'email',
        'User Created Date': {
          field: 'createAt',
          callback: (value) => {
            if (value) {
              let a = value.seconds
              let Fdate = new Date(0)
              Fdate.setSeconds(a)
              let day = Fdate.getDate()
              let month = Fdate.getMonth() + 1
              let year = Fdate.getFullYear()
              let dateShow = [year, month, day].join('-')
              return `${dateShow}`
            }
          }
        },
        'Latest Updated Date': {
          field: 'lastTransactions',
          callback: (value) => {
            if (value) {
              let a = value.map(x => x.createAt.seconds)
              let Fdate = new Date(0)
              Fdate.setSeconds(a[0])
              let day = Fdate.getDate()
              let month = Fdate.getMonth() + 1
              let year = Fdate.getFullYear()
              let dateShow = [year, month, day].join('-')
              return `${dateShow}`
            }
          }
        },
        'Count Updated': 'picCount',
        'Contest Picture': {
          field: 'lastTransactions',
          callback: (value) => {
            if (value.length > 0) {
              return `${value[0].rawPicUrl}`
            } else {
              return ''
            }
          }
        }
      }
      return Dates
    },
    snackbar: {
      set (value) {
        this.$store.dispatch('app/closeSnackbar')
      },
      get () {
        return this.$store.getters['app/getSnackbar']
      }
    },
    textsnackbar () {
      return this.$store.getters['app/gettextSnackbar']
    },
    colorsnackbar () {
      return this.$store.getters['app/getcolorStatusSnackbar']
    }
  }
}
</script>
<style>
table th + th { border-left:1px solid rgb(227,227,227); border-top:1px solid rgb(227,227,227); }
table td + td { border-left:1px solid rgb(227,227,227);  border-top:1px solid rgb(227,227,227);}
</style>
